// Ionic Starter App
// Database instance.
var db;
var internet_count=0;

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', [
	'ionic',
	'ionic-datepicker',
	'ion-floating-menu',
	'satellizer',
	'timer',
	'seatMap',
	'config',
	'factories',
	'services',
	'ngZ2UConverter',
	'barebone.menu',
	'barebone.home',
	'barebone.page',
	'barebone.member',
	'barebone.bus',
	'barebone.busseat',
	'barebone.transfer',
	'barebone.deposite',
	'barebone.truemoney',
	'barebone.bank',
	'barebone.buslist',
	'barebone.busdetail',
	'barebone.busbook',
	'barebone.myprofile',
	'barebone.mydeposite',
	'barebone.ticketchanges',
	'barebone.mychanges',
	'barebone.mybooking',
	'ngCordova',
	'language',
	'ionic-modal-select',
])

.value('_', window._)

.run(function($rootScope,$timeout, $ionicPlatform, $ionicHistory, $cordovaToast,$location,AppDB,ENV,LANG,$window,SqlDestinations,DBA) {

	  $rootScope.appName = ENV.appName;
	  $rootScope.appEmail = ENV.email;
	  $rootScope.appAddress = ENV.appAddress;
	  $rootScope.appPhone = ENV.phone1;
	  $rootScope.appType = ENV.appType;

	  // english2myanmarchange
    $rootScope.$on('$stateChangeStart', function (evt, toState) {

    		$rootScope.appSetting = ENV;

    		var lang_val = $window.localStorage['appLang'] || LANG.lang;
    		if(lang_val === 'english')
    		{
    	  $rootScope.appLang = LANG.english;
    		}
    		else{
      		$rootScope.appLang = LANG.myanmar;
    			}
	});	
     
      var actionId = "preventBack",
      priority = 101,
      
      backButtonCallback = function (e) {
        var backView = $ionicHistory.backView();
      
        if (backView) {
          // Look for a backview first, this way we don't interfere with the normal history stack
          // but only runs the close check just before we will actually close the app.
          backView.go();
        } else {
          // Go back to default behavior (close the app)
          $ionicPlatform.$deregisterBackButton(actionId); 
          
          // Show toast 400 pixels from bottom.
          $cordovaToast.showShortBottom("Press back again to exit", 400); 
          
          // Re-register this custom handling after X milliseconds.
          $timeout(function () { 
            $ionicPlatform.registerBackButtonAction(backButtonCallback, priority, actionId);
          }, 2000);
        }
      
        e.preventDefault();
        return false;
      };

  $ionicPlatform.registerBackButtonAction(backButtonCallback, priority, actionId);

	$ionicPlatform.ready(function() {
		// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
		// for form inputs)
		if (window.cordova && window.cordova.plugins.Keyboard) {
			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
			cordova.plugins.Keyboard.disableScroll(true);
		}
		if (window.StatusBar) {
			// StatusBar.overlaysWebView(true);
			StatusBar.styleLightContent();
		} 
       
	    
	    DBA.init();
	    SqlDestinations.initialize();

	    //add offline destinations data
	    var offline_des = [
						    {
						      "name": "Yangon",
						      "mm_name": "ရန်ကုန်",
						      "id": 1
						    },
						    {
						      "name": "Mandalay",
						      "mm_name": "မန္တလေး",
						      "id": 4
						    },
						    {
						      "name": "Taunggyi",
						      "mm_name": "တောင်ကြီး",
						      "id": 79
						    },
						    {
						      "name": "Bagan",
						      "mm_name": "ပုဂံ",
						      "id": 80
						    },
						    {
						      "name": "Naypyitaw",
						      "mm_name": "နေပြည်တော်",
						      "id": 81
						    }
						  ];
		for (var i = 0; i < offline_des.length; i++)
        { 
			SqlDestinations.add(offline_des[i]).then(function(result) {});
        }
        AppDB.init();
		
		var tempList = [];
		 tempList.route = 'app.about';
		 tempList.data = '{ "result": "<p>JJ Express Bus Ticket System သည္ၿမန္မာတစ္ၿပည္လံုးရွိအေ၀းေၿပးကားလိုင္းမ်ား၏ Up to Date သတင္းအခ်က္အလက္မ်ား (အခ်ိန္၊ ေစ်းႏွဳန္း) ကိုOnline Website ေပၚတြင္တစ္စုတစ္ေ၀းတည္း ေဖာ္ၿပထားၿခင္းၿဖစ္ၿပီး JJ Website တြင္ ကားလက္မွတ္မ်ားကို အခ်ိန္တိုအတြင္း ၀ယ္ယူနိဳင္မည့္အၿပင္ ကားစီးရန္ကားလက္မွတ္မ်ားကိုလည္း ၀ယ္ယူသူ၏ Mobile ဖုန္းထဲသို႕ SMS တိုက္ရိဳက္ေပးပို႔ၿခင္းၿဖင့္ အခ်ိန္ကုန္လူပင္ပန္းစရာမလိုပဲ ဂိတ္ရင္းေစ်းႏွဳန္းအတိုင္း ေရာင္းခ်ေပးသည့္ System ၿဖစ္သည္။ Payment (ေငြေပးေခ်မွဴ ) အပိုင္းကိုလည္း၊ လြယ္ကူေစရန္အတြက္ MPU (ATM) ကဒ္ၿဖင့္ေငြေပးေခ်စနစ္၊ ဘဏ္ေငြလႊဲစနစ္ႏွင့္ မိမိAccount ထဲတြင္ႀကိဳတင္ေငြထည့္သြင္းစနစ္မ်ားၿပဳလုပ္ထားပါသည္။</p><p>&nbsp;</p><p><strong>Our Group of Companies offer total flexibility within your budget range;</strong></p><p><strong>One stop bus ticketing service for any route through out Myanmar ( For Myanmar Local customer only)</strong></p><p><strong>"}';
		AppDB.addorupdate(tempList,'');
		//add offline faq us data
		tempList = [];
		tempList.route = 'app.faq';
		tempList.data = '{"result": "<strong>Q : What is the procedure with Bus ticketing system? </strong></p><p>A : As soon as we received the booking along with full payment , we will go ahead and book the seat. We will send out Initial sms to acknowledge within 48 hours of receiving your booking.&nbsp;</p><p>Due to the seat assign policy with Bus companies, we can only send complete SMS-ticket along with seat number 7 days before the travel date at earliest.</p><p>(Regarding with ticket for shared taxi, the seat number will come out only 3 days before the travel date due to the assign policy of Taxi companies)</p><p>---------------------------------------------------------------------------------------------</p><p><strong>Q : How soon will I get seat number? </strong></p><p>A : Due to the strict seat assignment policy of Bus companies, we can only provide the seat number 7 days before the travel date as earliest.</p><p>---------------------------------------------------------------------------------------------</p><p><strong>Q : How do I know /trace my ticket status?</strong></p><p><strong>A:</strong> You&nbsp;can always see the booking status and download the E-ticket when it is ready. All you have to do is type in the Ticket/Reference Number&nbsp;in the Track ticket status field on top right cornor of every page on our website.</p><p>(If your ticket is in complete stage, you can also directly download your complete e-ticket on it.)</p><p>----------------------------------------------------------------------------------------------</p><p><strong>Q : Why haven&#39;t I received my initial SMS with ticket information immediately after making the payment?</strong></p><p>A : Due to the fact that we review all bookings before processing further, it might takes sometime but no more than 48 hours.</p><p>---------------------------------------------------------------------------------------------</p><p><strong>Q : What is the office opening hours?</strong></p><p>A : Monday to Friday 9:00AM to 5:00PM and Saturday 9:00AM to 12:00PM, except public holiday.</p><p>---------------------------------------------------------------------------------------------</p><p><strong>Q :The Travel date is very close. What if I still haven&#39;t got the Complete SMS-ticket yet? </strong></p><p>A : You should receive your complete SMS-ticket 7 days before your travel date. Alternatively, you can download /track your e-ticket with ticket reference number on Home Page of our website (www.bnfexpress.com). You can also call us on 09254898255 .</p><p>---------------------------------------------------------------------------------------------</p><p><strong>Q : How are the payment process? Is it secure?</strong></p><p>A : We do accept either MPU cardpayment, bank transfer or deposit to our JJ registered account methods.</p><p>---------------------------------------------------------------------------------------------</p><p><strong>Q : Can&#39;t book some date. Why some date are blocked?</strong></p><p>A: There are certain days that some bus line doesn&#39;t run such as Myanmar New Year festival season.</p><p>---------------------------------------------------------------------------------------------</p><p><strong>Q : Why can&#39;t I book for tomorrow and the day after tomorrow?</strong></p><p>A: Our system only allow the booking that are 2 days in advance to Travel date so that it will give us sometime to review and operate before we actually issue the Complete ticket to our customer.&nbsp;</p><p>---------------------------------------------------------------------------------------------</p><p><strong>Q : What is the different between VIP 2+1 seat and Normal 2+2 seat?</strong></p><p>A: It mean the number of seat in a roll on bus which mean 2+1 has more space than 2+2.</p><p>---------------------------------------------------------------------------------------------</p><p><strong>Q : What do I need to bring to Bus station to take bus?</strong></p><p>A : You just need to provide our complete SMS or E-ticket at the Bus gate along with your NRC no to verify that you are the right passenger. Moreover, passengers are suggested to bring along their NRC when they travel at all time.</p><p>---------------------------------------------------------------------------------------------</p><p><strong>Q : Can I cancel or refund?</strong></p><p>A : Booking can&#39;t be cancelled or is non-refundable as we book and paid in full to the Bus company as soon as we received the booking from you so that we can secure nice seat for our customer.</p>"}';
		AppDB.addorupdate(tempList,'');

		//add offline faq us data
		 tempList = [];
		 tempList.route = 'app.tnc';
		 tempList.data = '{"result":"<p><strong>ခရီးသည္မ်ားသိရွိလိုက္နာရန္အခ်က္မ်ား</strong></p><p><strong>(၁)</strong> ၀ယ္ယူၿပီးေသာ ကားလက္မွတ္မ်ားကို ရက္ေၿပာင္းေရႊ႕ၿခင္း၊ အခ်ိန္ေၿပာင္းလဲၿခင္း၊ ေငြၿပန္အမ္းၿခင္းမ်ား ၿပဳလုပ္ေပးမည္ မဟုတ္ပါ။</p><p><strong>(၂)</strong> ယာဥ္ထြက္ခ်ိန္ထက္ ေက်ာ္လြန္ၿပီး ေနာက္က်မွေရာက္ရွိလာပါေသာ လက္မွတ္အတြက္ ေငြၿပန္အမ္းၿခင္း၊ တာ၀န္ယူေဆာင္ရြက္ေပးၿခင္း ၿပဳလုပ္မည္မဟုတ္ပါ။ </p><p><strong>(၃)</strong> ခရီးသြားမ်ားေသာ ရာသီ (သို႕) ယာဥ္လိုင္းမ်ား၏အေၿခအေန အမ်ိဳးမ်ိဳးေႀကာင့္ လူႀကီးမင္းတို့ေရြးခ်ယ္ထားသည့္ <strong>Bus Company</strong> မ်ား အေၿပာင္းအလဲရွိနိုင္ပါသည္။ ထိုသို့ေၿပာင္းလဲၿခင္းကိုလည္း ႀကိဳတင္အသိေပးညွိႏွိဳင္းေပးသြားပ"}';
		AppDB.addorupdate(tempList,'');
	});
})

.config(function($provide,$ionicConfigProvider,$authProvider,$urlRouterProvider,ionicDatePickerProvider,ENV) {

		$authProvider.baseUrl = ENV.apiEndpoint;

		// Facebook
		$authProvider.facebook({
		  name: 'facebook',
		  clientId: '604952036368181',
		  url: ENV.apiEndpoint +'auth/facebook',
		  authorizationEndpoint: 'https://www.facebook.com/v2.9/dialog/oauth',
		  redirectUri: ENV.apiEndpoint + 'auth/facebook/callback',
		  requiredUrlParams: ['display', 'scope'],
		  scope: ['email'],
		  scopeDelimiter: ',',
		  platform: 'mobile',
		  display: 'popup',
		  type: '2.0',
		  popupOptions: { width: 580, height: 400 }
		});

	    var datePickerObj = {
	      setLabel: 'Set',
	      todayLabel: 'Today',
	      closeLabel: 'Go Back',
	      mondayFirst: true,
	      inputDate: new Date(),
	      weeksList: ["S", "M", "T", "W", "T", "F", "S"],
	      monthsList: ["Jan", "Feb", "March", "April", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec"],
	      templateType: 'popup',
	      showTodayButton: false,
	      dateFormat: 'dd MMM yyyy',
	      closeOnSelect: true,
	      disableWeekdays: [],
	      from: new Date()
	    };

	  ionicDatePickerProvider.configDatePicker(datePickerObj);

	  $provide.decorator("$ionicPlatform", ["$delegate", function ($delegate) {

	  $delegate.$deregisterBackButton = function (actionId) {
	      delete $delegate.$backButtonActions[actionId];
	    };

	    return $delegate;
	  }]);

	$ionicConfigProvider.views.maxCache(2);
	$urlRouterProvider.otherwise('/app/busSearch');
});