(function() {
	'use strict';

	angular
		.module('barebone.bus')
		.factory('busService', busService);

	busService.$inject = ['$http', '$q', 'ENV','$rootScope','SqlDestinations'];

	/* @ngInject */
	function busService($http, $q, ENV,$rootScope,SqlDestinations) {

		var url = ENV.apiEndpoint;
		var result = [];
		var busLists = [];


		return {
			getServicefees: getServicefees,
			getSeatblocked: getSeatblocked,
			bookedSeat	  : bookedSeat,
			getSeatviews  : getSeatviews,
			getDestination: getDestination,
			getBusroutes  : getBusroutes,
			get           : get
		};


	function bookedSeat(busId,seatId,traveldate,selected_seat,total_amount,adult,promo_code){

			var deferred = $q.defer();
			if(!promo_code)promo_code=0;

			$http.get(url+'booked_seat/'+busId+'/'+seatId+'/'+traveldate+'/'+selected_seat+'/'+total_amount+'/'+adult+'/'+promo_code)
				.success(function(data, status, headers, config) {
					// this callback will be called asynchronously
					// when the response is available
					result = data;
					deferred.resolve(result);
				})
				.error(function(data, status, headers, config) {
					// called asynchronously if an error occurs
					// or server returns response with an error status.
					console.log('ERROR (Destinations):' + status);
					deferred.reject(result);
				});
			return deferred.promise;
	}

	function getSeatblocked(busId,seatId,traveldate){
			var deferred = $q.defer();
			var sdate = traveldate.split('-');
			if (sdate[0].length == 1)
		    {
		        traveldate = "0" + traveldate;
		    }
			$http.get(url+'seats_blocked/'+busId+'/'+seatId+'/'+traveldate)
				.success(function(data, status, headers, config) {
					// this callback will be called asynchronously
					// when the response is available
					result = data;
					deferred.resolve(result);
				})
				.error(function(data, status, headers, config) {
					// called asynchronously if an error occurs
					// or server returns response with an error status.
					console.log('ERROR (Destinations):' + status);
					deferred.reject(result);
				});
			return deferred.promise;
	}

	function getSeatviews(busId,seatId,adult,traveldate){

		var deferred = $q.defer();
			$http.get(url+'view_seats/'+busId+'/'+seatId+'/'+adult+'/'+traveldate)
				.success(function(data, status, headers, config) {
					// this callback will be called asynchronously
					// when the response is available
					result = data;
					deferred.resolve(result);
				})
				.error(function(data, status, headers, config) {
					// called asynchronously if an error occurs
					// or server returns response with an error status.
					console.log('ERROR (Destinations):' + status);
					deferred.reject(result);
				});
			return deferred.promise;

	}

	function getServicefees(amount){

		var deferred = $q.defer();
			$http.get(url+'booking_service_fees/'+amount)
				.success(function(data, status, headers, config) {
					// this callback will be called asynchronously
					// when the response is available
					result = data;
					deferred.resolve(result);
				})
				.error(function(data, status, headers, config) {
					// called asynchronously if an error occurs
					// or server returns response with an error status.
					console.log('ERROR (Destinations):' + status);
					deferred.reject(result);
				});
			return deferred.promise;

	}

	function getDestination(){

			var deferred = $q.defer();
			$http.get(url+'agent_destinations')
				.success(function(data, status, headers, config) {
					// this callback will be called asynchronously
					// when the response is available
					result = data.result;
					for (var i = 0; i < result.length; i++)
			        { 
			        	result[i].mm_name = zg2uni(result[i].mm_name);
						SqlDestinations.add(result[i]).then(function(result) {});
			        }
					// $rootScope.set('destinations', result);
					deferred.resolve(result);
				})
				.error(function(data, status, headers, config) {
					// called asynchronously if an error occurs
					// or server returns response with an error status.
					console.log('ERROR (Destinations):' + status);
					deferred.reject(result);
				});
			return deferred.promise;
	}

	function getBusroutes(page,searchResult){

			var mybooking = {
					
					from_to	: searchResult.from_destination +'-to-'+ searchResult.to_destination,
					travel_date	: searchResult.traveldate,
					adult	    	: searchResult.adult,
					page	    	: page,
					bus_qty	: 5
     		    	};			

			var deferred = $q.defer();

			 	$http({
			                    url: url+'buses',
			                    method: "GET",
			                    params: mybooking
			                })
				.success(function(data, status, headers, config) {
					// this callback will be called asynchronously
					// when the response is available
					busLists = data;
					deferred.resolve(data);
				})
				.error(function(data, status, headers, config) {
					// called asynchronously if an error occurs
					// or server returns response with an error status.
					// console.log('ERROR (Buses):' + status);
					deferred.reject(busLists);
				});
			return deferred.promise;
	}

	function get(busId) {

			// we take a product from cache but we can request ir from the server
			for (var i = 0; i < $rootScope.busLists.length; i++) {
				if ($rootScope.busLists[i].id == busId) {
					return $q.when($rootScope.busLists[i]);
				}
			}
			return $q.when(null);

	}

}

})();