(function() {
	'use strict';

	angular
		.module('barebone.member')
		.controller('MemberController', MemberController);

	MemberController.$inject = [
		'memberService',
		'$timeout',
		'$scope',
		'$window',
		'$location',
		'$state',
		'$auth',
		'$rootScope',
		'$q',
		'motion',
		'externalAppsService',
		'ENV'
	];

	/* @ngInject */
	function MemberController(
		memberService, $timeout,$scope,$window,$location,$state,$auth,$rootScope,$q,motion,externalAppsService,ENV) {

		var vm = angular.extend(this, {
			registerLink : ENV.liveSite +'register',
			singup		 : singup,
			login		 : login,
	facebookSignIn		 : facebookSignIn,
			mobile		 : '09',
			password	 : ''
		});

		(function activate(){
			motion.expandHeader();
			motion.ink();

		})();

		function singup(){
			$window.open(vm.registerLink, '_blank', 'closebuttoncaption=Back to Login');
			return false;
		}

		function login(){
			$rootScope.$broadcast('loading:show');
			memberService.doLogIn(vm.mobile,vm.password).then(function(member) {
				$rootScope.$broadcast('loading:hide');
				$rootScope.$broadcast('load:Islogin');
				$state.go('app.busSearch');
				 $window.location.href = 'index.html';
			});			
		}

		//This method is executed when the user press the "Login with facebook" button
		function facebookSignIn() {

			$auth.authenticate('facebook').then(function(token){
				$state.go('app.busSearch');
				$window.location.href = 'index.html';
			},function(data, status, headers, config){
				console.log('ERROR (FB Login):' + status);
			});

		}

	}
})();