(function() {
	'use strict';

	angular
		.module('barebone.menu')
		.controller('MenuController', MenuController);

	MenuController.$inject = ['$scope','homeDataService','$timeout','$rootScope','$window','$auth','$state','$ionicActionSheet','LANG'];

	/* @ngInject */
	function MenuController($scope,homeDataService,$timeout,$rootScope,$window,$auth,$state,$ionicActionSheet,LANG) {

		// document.addEventListener("resume", function () {
		// 	$state.go('app.busSearch');
		// });

		var vm = angular.extend(this, {
			isExpanded: false,
			goLogin : goLogin,
			userInfo : $rootScope.userInfo,
			phoneNumber: homeDataService.phoneNumber,
			showActions:showActions
		});

		$scope.$on('header-expanded', function(event, args) {
			vm.isExpanded = args.expanded;
		});


		function showActions() {
			if($state.current.name == 'app.home' || $state.current.name == 'app.busSearch'){

				$ionicActionSheet.show({
				buttons: [
								{ text: $rootScope.appLang.my_profile },
								{ text: 'English' },
								{ text: 'မြန်မာ' },
								{ text: $rootScope.appLang.logout }
						 ],
				titleText: $rootScope.appLang.account_setting,
				cancelText: $rootScope.appLang.back,
					buttonClicked: function(index) {
						switch(index) {
							case 0:
								$state.go('app.myprofile');
								break;
							case 1:
								$window.localStorage['appLang'] = 'english';
				                $rootScope.appLang = LANG.english;
				                $window.location.href = 'index.html';
								break;
							case 2:
								$window.localStorage['appLang'] = 'myanmar';
				                $rootScope.appLang = LANG.myanmar;
				                $window.location.href = 'index.html';
								break;
							case 3:
								$auth.logout();
								$rootScope.isLogin = false;
								$rootScope.userInfo = '';
								$window.localStorage['userInfo']='';
    							$window.localStorage['username']='';
    							$window.localStorage['password']='';
    							$window.localStorage['child_reseller']='';
    							$window.location.reload(true);
								break;
						}
						return true;
					}
				});
			}
			else{

				$ionicActionSheet.show({
				buttons: [
								{ text: $rootScope.appLang.my_profile },
								{ text: $rootScope.appLang.logout }
						  ],
				titleText: $rootScope.appLang.account_setting,
				cancelText: $rootScope.appLang.back,
					buttonClicked: function(index) {
						switch(index) {
							case 0:
								$state.go('app.myprofile');
								break;
							case 1:
								$auth.logout();
								$rootScope.isLogin = false;
								$rootScope.userInfo = '';
								$window.localStorage['userInfo']='';
    							$window.localStorage['username']='';
    							$window.localStorage['password']='';
    							$window.localStorage['child_reseller']='';
    							$window.location.reload(true);
								break;
						}
						return true;
					}
				});
			}
		}

		function goLogin()
		{
			$state.go('app.login');
		}
	}
})();