(function() {
	'use strict';

	angular
		.module('barebone.mybooking')
		.factory('mybookingService', mybookingService);

	mybookingService.$inject = ['$http', '$q','$auth', 'ENV','$ionicPopup','$ionicLoading'];

	/* @ngInject */
	function mybookingService($http, $q,$auth, ENV,$ionicPopup,$ionicLoading) {

		var url = ENV.apiEndpoint;
		var result = [];

		return {
			getBooking: getBooking
		};


	// *******************************************************

	function getBooking(page){

			var deferred = $q.defer();
			
			$http.get(url+'mybooking?page='+page+'&token='+$auth.getToken(),{}).then(function(data) {

						result = data;
						deferred.resolve(result);

					}, function(error) {
						$ionicLoading.hide();
						$ionicPopup.alert({
				            title: 'Error',
				            content: 'Can\'t establish internet connection.'
				          });
						deferred.reject(result);
					});

			return deferred.promise;

	}

}

})();