(function() {
	'use strict';

	angular
		.module('barebone.mychanges')
		.controller('MychangesController', MychangesController);

	MychangesController.$inject = [
		'$scope',
		'mychangesService',
		'$rootScope',
		'$timeout',
		'$state',
		'$auth',
		'$ionicPopup',
		'$window',
		'motion'
	];

	/* @ngInject */
	function MychangesController($scope, mychangesService, $rootScope,$timeout,$state,$auth,$ionicPopup,$window,motion) {

		var user_child_id = ($window.localStorage['child_reseller'])?JSON.parse($window.localStorage['child_reseller']).id:0;

		var vm = angular.extend(this, {
			userprofile  : $rootScope.userInfo,
		   user_child_id : user_child_id,			
			loadchanges : loadchanges,			
			page 		 : 1,
			totalPages	 : 1,
			moreDataCanBeLoaded : moreDataCanBeLoaded,
			loadMore : loadMore,
				  changes : {}
		});
		
		(function activate() {
			mychangesService.getChanges(vm.page)
			.then(function(data) {
				vm.totalPages = data.data.last_page;		
				vm.changes = data.data.data;
			});
			motion.expandHeader();
		})();

		function moreDataCanBeLoaded(){
			return vm.totalPages > vm.page;
		}

		function loadchanges() {
			vm.page = 1;
			mychangesService.getChanges(vm.page)
			.then(function(data) {
				vm.totalPages = data.data.last_page;		
				vm.changes = data.data.data;
				$scope.$broadcast('scroll.refreshComplete');
			});
		}

		function loadMore() {
			vm.page += 1;
			mychangesService.getChanges(vm.page)
			.then(function(data) {
				vm.totalPages = data.data.last_page;
				var new_moneydata = data.data.data;
				vm.changes = vm.changes.concat(new_moneydata);
				$scope.$broadcast('scroll.infiniteScrollComplete');
			});
		}


	}
})();