(function() {
	'use strict';

	angular
		.module('barebone.mychanges')
		.factory('mychangesService', mychangesService);

	mychangesService.$inject = ['$http', '$q','$auth', 'ENV','$ionicPopup','$ionicLoading'];

	/* @ngInject */
	function mychangesService($http, $q,$auth, ENV,$ionicPopup,$ionicLoading) {

		var url = ENV.apiEndpoint;
		var result = [];

		return {
			getChanges: getChanges
		};


	function getChanges(page){

			var deferred = $q.defer();
			
			$http.get(url+'mychanges?page='+page+'&token='+$auth.getToken(),{}).then(function(data) {

						result = data;
						deferred.resolve(result);

					}, function(error) {
						$ionicLoading.hide();
						$ionicPopup.alert({
				            title: $rootScope.appLang.invalid,
				            content: $rootScope.appLang.cant_establish_conn
				          });
						deferred.reject(result);
					});

			return deferred.promise;

	}

}

})();