(function() {
	'use strict';

	angular
		.module('barebone.mydeposite')
		.controller('MydepositeController', MydepositeController);

	MydepositeController.$inject = [
		'$scope',
		'mydepositeService',
		'$rootScope',
		'$timeout',
		'$state',
		'$auth',
		'$ionicPopup',
		'motion'
	];

	/* @ngInject */
	function MydepositeController($scope, mydepositeService, $rootScope,$timeout,$state,$auth,$ionicPopup,motion) {

		var vm = angular.extend(this, {
			userprofile  : $rootScope.userInfo,
			loaddeposite : loaddeposite,			
			page 		 : 1,
			totalPages	 : 1,
			moreDataCanBeLoaded : moreDataCanBeLoaded,
			loadMore : loadMore,
				  moneys : {}
		});
		
		(function activate() {
			mydepositeService.getDeposite(vm.page)
			.then(function(data) {
				vm.totalPages = data.data.last_page;		
				vm.moneys = data.data.data;
			});
			motion.expandHeader();
		})();

		function moreDataCanBeLoaded(){
			return vm.totalPages > vm.page;
		}

		function loaddeposite() {
			vm.page = 1;
			mydepositeService.getDeposite(vm.page)
			.then(function(data) {
				vm.totalPages = data.data.last_page;		
				vm.moneys = data.data.data;
				$scope.$broadcast('scroll.refreshComplete');
			});
		}

		function loadMore() {
			vm.page += 1;
			mydepositeService.getDeposite(vm.page)
			.then(function(data) {
				vm.totalPages = data.data.last_page;
				var new_moneydata = data.data.data;
				vm.moneys = vm.moneys.concat(new_moneydata);
				$scope.$broadcast('scroll.infiniteScrollComplete');
			});
		}


	}
})();