(function() {
	'use strict';

	angular
		.module('starter')
		.run(function($rootScope,$timeout,$ionicLoading,$ionicPopup,$interval,$state,$auth,$window,$http,ENV,$location) {
			$rootScope.$on('loading:show', function() {
				$ionicLoading.show({});
			});

			$rootScope.call_contact1 = function() {
				$window.open('tel:'+ENV.phone1,'_system');
			}
			$rootScope.call_contact2 = function() {
				$window.open('tel:'+ENV.phone2,'_system');
			}
			$rootScope.search_trackticket = function() {
				$state.go('app.searchticket');
			}

			$rootScope.$on('loading:hide', function() {
				$ionicLoading.hide();
			});

			$rootScope.$on('$stateChangeStart', function () {
			    console.log('please wait...');
			    $("#resolve_load").removeClass("hide");
			});

			$rootScope.$on('$stateChangeSuccess', function () {
			    console.log('done');
			    $("#resolve_load").addClass("hide");
			});

			$rootScope.$on('load:Islogin', function() { 
				if($auth.getToken())
				{
					$rootScope.$broadcast('load:logincheck');
					$rootScope.isLogin = true;
					$state.go('app.home');
				}
				else
				{
					$rootScope.isLogin = false;
					$state.go('app.login');
				}
			});

			$rootScope.$on('load:logincheck', function() { 
					$interval(function() {
							$rootScope.disableLoader = true;
							if($auth.getToken()){

									$rootScope.isLogin = true;

									$http.get(ENV.apiEndpoint+'authenticate?token='+$auth.getToken()).then(function(response) {
												// If login is successful, redirect to the users state
												$rootScope.userInfo = response.data;

											}, function(error) {
												$rootScope.disableLoader = true;
												$http.get(ENV.apiEndpoint+'tokenrefresh?token='+$auth.getToken()).then(function(response) {
														// If login is unsuccessful, redirect to the users state
														var token = response.data.token;
														$auth.setToken(token,$location.path());

													},function(error){
														$auth.logout();
														$ionicLoading.hide();
														$rootScope.isLogin = false;
													});

											});

						 	}
						 	else{
								$rootScope.isLogin = false;
						 	}
					},5000);
			});

			if($auth.getToken())
			{
				$rootScope.isLogin = true;
				$rootScope.$broadcast('load:logincheck');
			}
		});
})();
