(function() {
	'use strict';

	angular
		.module('barebone.ticketchanges')
		.controller('TicketchangesController', TicketchangesController);

	TicketchangesController.$inject = [
		'busService',
		'$scope',
		'ticketchangesService',
		'$rootScope',
		'$timeout',
		'$state',
		'$auth',
		'$ionicPopup',
		'$window',
		'$ionicHistory',
		'$ionicModal',
		'$filter',
		'$http',
		'booking',
		'ENV',
		'motion'
	];

	/* @ngInject */
	function TicketchangesController(busService,$scope, ticketchangesService, $rootScope,$timeout,$state,$auth,$ionicPopup,$window,$ionicHistory,$ionicModal,$filter,$http,booking,ENV,motion) {


		$ionicHistory.nextViewOptions({
	            historyRoot: true
	    });

		$scope.today = new Date();
		
		var userInfo       = $rootScope.userInfo || {};
		var changesbooking = booking;

		var        booking = changesbooking.booking;
		var        bus     = changesbooking.bus;
		var        cms     = changesbooking.cms;

		var vm = angular.extend(this, {
				 disabled_book   : false,
					liveSite 	 : ENV.liveSite,
					userInfo 	 : userInfo,
					image 		 : 'images/logo.png',
					hidefab 	 : true,
				changesbooking 	 : changesbooking,
					booking 	 : booking,
					bus 	     : bus,
					cms 	     : cms,
				transfer_payment : true,
			   truemoney_payment : false,
			 onetwothree_payment : false,
				  paypal_payment : false,
			 visa_master_payment : true,
			 kbz_direct_payment  : true,
					 mab_payment : false,
					 mpu_payment : true,
				deposite_payment : true,
			from_destination 	 : bus.from_destination.name,
			to_destination     	 : bus.to_destination.name,
					type 		 : booking.type,
					redirectHome : redirectHome,
					changeMode	 : changeMode,
			showconfirmation	 : showconfirmation,
					conBooking	 : conBooking,
					dollar_rate  : $window.localStorage['dollar_rate'],
					detectFont	 : detectFont
		});

			$ionicModal.fromTemplateUrl('scripts/booking/booking-confirm.html', {
					    vm: vm,
					    scope: $scope,
					    animation: 'slide-in-down'
			}).then(function(modal) {
					    $scope.modal = modal;
			});


			motion.expandHeader();
			// **********************************************

			var busId = booking.bus_id;
			var service_fees = booking.service_fee;

			vm.booking.adult      = parseInt(booking.adult);
			vm.booking.bus_id     = busId;
			vm.booking.travel_date = booking.travel_date;
			
			vm.booking.type        = booking.type;
			vm.booking.passenger_type        = booking.passenger_type;
			vm.booking.seat_id     = booking.seat_id;
			vm.booking.selected_seat     = booking.selected_seat;
			vm.booking.seat_no           = booking.seat_no;
			vm.booking.mobile   = '';
			vm.booking.accept_terms   = '';
			vm.booking.payment  = 'account';
			vm.booking.note  	= '';
			vm.booking.transcation  = 'TXN Fees';
			vm.booking.transcation_fees  = 0;
			vm.booking.comission  = 0;

			vm.booking.service_fees  = 0;

			vm.booking.service = 0;

			vm.booking.sell_price   = parseFloat(vm.booking.price);

			vm.booking.total	= (vm.booking.adult*vm.booking.price) - vm.booking.discount - service_fees;
			vm.booking.total_sellprice	= (vm.booking.adult*vm.booking.sell_price) - vm.booking.discount - service_fees;
			vm.booking.refund_amount	= vm.changesbooking.refund_amount;
			vm.booking.refund_info	    = vm.changesbooking.refund_info;

			busService.getServicefees(vm.booking.refund_amount)
				.then(function(serviceFees) {
					vm.booking.transcation_fees = serviceFees.transfer_fee;
					if(serviceFees.transfer_fee) vm.transfer_payment = true;
					if(serviceFees.truemoney_fee) vm.truemoney_payment = true;
					if(serviceFees.onetwothree_fee) vm.onetwothree_payment = true;
					if(serviceFees.paypal_fee) vm.paypal_payment = true;
					if(serviceFees.visa_master_fee) vm.visa_master_payment = true;
					if(serviceFees.mab_fee) vm.mab_payment = true;
					if(serviceFees.mpu_fee) vm.mpu_payment = true;
					if(serviceFees.kbz_direct_fee) vm.kbz_direct_payment = true;
					if(typeof $rootScope.userInfo != 'undefined' && serviceFees.deposite_fee == 0 || serviceFees.deposite_fee > 0) vm.deposite_payment = true;
					
					if(!$rootScope.userInfo && !serviceFees.transfer_fee && !serviceFees.truemoney_fee && !serviceFees.onetwothree_fee && !serviceFees.paypal_fee && !serviceFees.visa_master_fee && !serviceFees.mab_fee && !serviceFees.mpu_fee){
						$ionicPopup.alert({
							    title: 'Sorry',
							    template: 'There is no payment avaliable for booking.Please login and checkout with Deposite Account!'
							  });
						$state.go('app.buslist');
					}

					vm.booking.payment = 'mpu';
					changeMode();
			});

			vm.booking.payment = 'account';

		function detectFont(text){
			return FontDetectService.fontDetect(text);
		}

		function redirectHome(){
			$state.go('app.home');
		}

		function changeMode(){

			vm.booking.sell_price   = parseFloat(vm.booking.price);

			vm.booking.total	= (vm.booking.adult*vm.booking.price) - vm.booking.discount - service_fees;
			vm.booking.total_sellprice	= (vm.booking.adult*vm.booking.sell_price) - vm.booking.discount - service_fees;
			vm.booking.refund_amount	= vm.changesbooking.refund_amount;
			vm.booking.refund_info	    = vm.changesbooking.refund_info;


			busService.getServicefees(vm.booking.refund_amount)
				.then(function(serviceFees) {
					
					if(vm.booking.payment == 'transfer'){
						vm.booking.transcation_fees = serviceFees.transfer_fee;
						vm.booking.service_fees = serviceFees.transfer_fee;
					}
					else if(vm.booking.payment == 'mpu'){
						vm.booking.transcation_fees = serviceFees.mpu_fee;
						vm.booking.service_fees = serviceFees.mpu_fee;
					}
					else if(vm.booking.payment == 'kbz_direct'){
						vm.booking.transcation_fees = serviceFees.kbz_direct_fee;
						vm.booking.service_fees = serviceFees.kbz_direct_fee;
					}
					else if(vm.booking.payment == 'onetwothree'){
						vm.booking.transcation_fees = serviceFees.onetwothree_fee;
						vm.booking.service_fees = serviceFees.onetwothree_fee;
					}
					else if(vm.booking.payment == 'paypal'){
						vm.booking.transcation_fees = serviceFees.paypal_fee;
						vm.booking.service_fees = serviceFees.paypal_fee;
					}
					else if(vm.booking.payment == 'visa_master'){
						vm.booking.transcation_fees = serviceFees.visa_master_fee;
						vm.booking.service_fees = serviceFees.visa_master_fee;
					}
					else if(vm.booking.payment == 'truemoney'){
						vm.booking.transcation_fees = serviceFees.truemoney_fee;
						vm.booking.service_fees = serviceFees.truemoney_fee;
					}
					else{
						vm.booking.transcation_fees = serviceFees.deposite_fee;
						vm.booking.service_fees = serviceFees.deposite_fee;
					}

					if(vm.offerAmount.offer_amount){
						vm.booking.transcation_fees -= vm.offerAmount.offer_amount;
					}

			});

		}


		function showconfirmation(){

				 var amount = parseFloat(vm.booking.refund_amount) + parseFloat(vm.booking.transcation_fees);

	 	 		 var depature_time = $filter('date')(($filter('date')(new Date(), 'y-MM-dd') +'T'+vm.bus.departure_time+':00'), "h:mm a");

	 	 		 vm.des = "Are you sure want to this book <b>"+ vm.from_destination + "</b> To <b>" + vm.to_destination+
	 	      			   "</b> Bus? <br><br>Travel Date : <b>"+ vm.booking.travel_date + "</b> <br><br>"+
	 	      			   $rootScope.appLang.depature_time +" : <b>"+ depature_time + "</b><br><br>"+
	 	      			   " Transcation Fees : <b>"+ vm.booking.service_fees + "</b><br><br>"+
	 	      			   " Changes Amount : <b>"+ amount + "</b><br><br>"+
	 	      			   "Payment Method : <b>"+ vm.booking.payment+"</b>";

			  $scope.modal.show();		
			  
			  //Cleanup the modal when we're done with it!
			  $scope.$on('$destroy', function() {
			    $scope.modal.remove();
			  });
			  // Execute action on hide modal
			  $scope.$on('modal.hidden', function() {
			    // Execute action
			  });
			  // Execute action on remove modal
			  $scope.$on('modal.removed', function() {
			    // Execute action
			  });


		}

		function conBooking(){

			vm.disabled_book = true;
			
			var amount = parseFloat(vm.booking.refund_amount) + parseFloat(vm.booking.transcation_fees);

			if(vm.booking.payment == 'account')
			{
				if($rootScope.userInfo && amount > $rootScope.userInfo.money)
				{
					$ionicPopup.alert({
							            title: $rootScope.appLang.insufficient_fund,
							            content: $rootScope.appLang.insufficient_fund_msg
							          });
					$scope.modal.hide();
					return false;
				}
				if(!$rootScope.userInfo)
				{
					$ionicPopup.alert({
							            title: 'Please Login',
							            content: 'Sorry,you didn\'t login or register yet.<br>Please login to your account first!'
							          });
					$state.go('app.login');
					$scope.modal.hide();
					return false;
				}

			}


			$http.get(ENV.apiEndpoint+'make_changes/'+vm.booking.payment+'/'+vm.changesbooking.encrypt_booking_id+'?token='+$auth.getToken(),{}).success(function(response) {

						$scope.modal.hide();
						$rootScope.bookedsuccess = response;

						if(vm.booking.payment == 'transfer'){
							$state.go('app.transfer');
						}
						else if(vm.booking.payment == 'truemoney'){
							$state.go('app.truemoney');
						}
						else if(vm.booking.payment == 'account'){
							$state.go('app.deposite');
						}
						else{

							var booking_id = response.encrypt_booking_id;
							var url = ENV.liveSite+'booking/refund_now/'+vm.booking.payment+'/'+booking_id;

							$window.open(url, '_blank', 'closebuttoncaption='+$rootScope.appLang.back);	
							$ionicPopup.alert({
							            title: $rootScope.appLang.success,
							            content: 'Your Changes Booking has been saved successfully.<br>Please feel free to email '+ENV.email+' if you need further information or assistance.'
							          });
							$state.go('app.busSearch');

						}
											
			}).error(function(response){
				$scope.modal.hide();
				$ionicPopup.alert({
				            title: 'Error!',
				            content: response.message
				          });
				$state.go('app.home');
			});

			
		}

	}
})();